#define  _WIN32_WINNT 0x0600
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>


/*
 * Message-only window callback function, handling the WM_HOTKEY events
 */
LRESULT CALLBACK MainWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  switch (uMsg)
  {
    // register the hotkey on startup
    case WM_CREATE:
      RegisterHotKey(hWnd,0x1337,MOD_ALT,VkKeyScan('1'));
      break;

    // * Find the window of TTOTAL_CMD class name (only one)
    // * Set the window on top
    // * Maximize it
    case WM_HOTKEY:
      {
        HWND hMainWnd = FindWindow("TTOTAL_CMD",NULL);
        SetForegroundWindow(hMainWnd);
        ShowWindow(hMainWnd,SW_SHOWMAXIMIZED);
      }
      break;

    // Unregister the old hotkey on exit
    case WM_CLOSE:
      UnregisterHotKey(hWnd,0x1337);

    default:
      return (DefWindowProc(hWnd, uMsg, wParam, lParam));
  }
  
  return 0;
}


/* 
 * Function where a separate thread starts - creates a Msg-only window and executes the event-dispatching loop
 */
DWORD MessageOnlyWindow(LPVOID arg)
{
  MSG msg;
  WNDCLASS wndclass;

  wndclass.style = 0; 
  wndclass.lpfnWndProc = MainWndProc; 
  wndclass.cbClsExtra = 0; 
  wndclass.cbWndExtra = 0; 
  wndclass.hInstance = GetModuleHandle(0); 
  wndclass.hIcon = NULL; 
  wndclass.hCursor = 0; 
  wndclass.hbrBackground = 0; 
  wndclass.lpszMenuName = NULL; 
  wndclass.lpszClassName = TEXT("TotalcmdBringToTop"); 

  if(RegisterClass(&wndclass) == 0) 
    return FALSE; 

  if(CreateWindow(TEXT("TotalcmdBringToTop"), TEXT("TotalcmdBringToTop"), 0,CW_USEDEFAULT, CW_USEDEFAULT,
                  CW_USEDEFAULT, CW_USEDEFAULT, HWND_MESSAGE, NULL, GetModuleHandle(0), NULL) == NULL)
    return FALSE;

  while(GetMessage(&msg, NULL, 0, 0))
  {
    TranslateMessage(&msg);
    DispatchMessage(&msg);
  }

  return msg.wParam;
}


BOOL WINAPI DllMain(
  HANDLE hinstDLL, 
  DWORD dwReason, 
  LPVOID lpvReserved
)
{
  if(dwReason!=DLL_PROCESS_ATTACH) return TRUE;

  // Create a single thread on process startup
  CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)MessageOnlyWindow,NULL,0,NULL);
  
  return TRUE;
}

